#include "CLibrary.h"

#include <stdio.h>

CLibrary::CLibrary(const char * name)
{
	unsigned int m_iLen = strlen(name);
	char * m_szName = new char[m_iLen+5];
	strcpy(m_szName, name);
#if defined _WIN32
	strcpy(m_szName+m_iLen, ".dll");
	m_hLibrary = LoadLibraryA(m_szName);
#elif defined _LINUX
	strcpy(m_szName+m_iLen, ".so");
	m_hLibrary = dlopen(m_szName, RTLD_NOW);
#endif
	delete m_szName;
}

void * CLibrary::getAddress(const char * name)
{
	if(!m_hLibrary)
		return 0;
#if defined _WIN32
	return GetProcAddress((HMODULE)m_hLibrary, name);
#elif defined _LINUX
	return dlsym(m_hLibrary, name);
#endif
}

CLibrary::~CLibrary()
{
#if defined _WIN32
	FreeLibrary((HMODULE)m_hLibrary);
#elif defined _LINUX
	dlclose(m_hLibrary);
#endif
}
