#include "extension.h"

#if SOURCE_ENGINE >= SE_CSGO
SH_DECL_HOOK1_void(IServerGameDLL, GameServerSteamAPIActivated, SH_NOATTRIB, 0, bool);
#else
SH_DECL_HOOK0_void(IServerGameDLL, GameServerSteamAPIActivated, SH_NOATTRIB, 0);
#endif

VoiceHook2 g_VoiceHook2;		/**< Global singleton for extension's main interface */
IClientAudio * g_pClientAudio = NULL;
IGameConfig *g_pGameConf = NULL;
IServerGameDLL *server = NULL;
ICvar *icvar = NULL;
ConVar *g_pUseSteamVoice = NULL;
CDetour *g_pBroadcastVoiceData = NULL;
IForward *g_pOnBroadcastVoice = NULL;

IClientEngine * g_pClientEngine = NULL;
ISteamClient012 * g_pSteamClient = NULL;
ISteamUser017 * g_pSteamUser = NULL;
HSteamPipe g_hPipe;
HSteamUser g_hUser;

void *state;
SpeexBits bits;

SMEXT_LINK(&g_VoiceHook2);

DETOUR_DECL_STATIC4(SV_BroadcastVoiceData, void, IClient*, client, int, nBytes, char *, pVoiceData, long long, unk4)
{
	uint32 m_unWritten = 0;
	char m_Uncompressed[22*1024];

	if(g_pUseSteamVoice && g_pUseSteamVoice->GetBool())
	{
		EVoiceResult ret = k_EVoiceResultNoData;

		std::string * msg = (std::string*)pVoiceData;

		if(g_pClientAudio)
			ret = g_pClientAudio->DecompressVoice(pVoiceData, nBytes, m_Uncompressed, sizeof(m_Uncompressed), &m_unWritten, 11025);
		else if(g_pSteamUser)
			ret = g_pSteamUser->DecompressVoice(pVoiceData, nBytes, m_Uncompressed, sizeof(m_Uncompressed), &m_unWritten, 11025);
		
		if(ret == k_EVoiceResultOK && g_pOnBroadcastVoice && m_unWritten)
		{		
			cell_t result = 0;
			g_pOnBroadcastVoice->PushCell(client->GetPlayerSlot()+1);
			g_pOnBroadcastVoice->PushStringEx(m_Uncompressed, m_unWritten, SM_PARAM_STRING_COPY|SM_PARAM_STRING_BINARY, 0);
			g_pOnBroadcastVoice->PushCell(m_unWritten);
			g_pOnBroadcastVoice->Execute(&result);
		}
	}
	else
	{
		short m_unOutput[160];
		speex_bits_read_from(&bits, pVoiceData, nBytes);
		while(speex_bits_remaining(&bits) > 0)
		{
			int ret = speex_decode_int(state, &bits, m_unOutput);

			if(ret == 0)
				speex_bits_advance(&bits, speex_bits_remaining(&bits)%8);
			else
				break;

			for (unsigned int i=0;i<160 && m_unWritten < sizeof(m_Uncompressed);i++)
			{
				*(short*)(m_Uncompressed+m_unWritten+i*2)=m_unOutput[i];
			}
			m_unWritten += 320;
		}

		cell_t result = 0;
		g_pOnBroadcastVoice->PushCell(client->GetPlayerSlot()+1);
		g_pOnBroadcastVoice->PushStringEx(m_Uncompressed, m_unWritten, SM_PARAM_STRING_COPY|SM_PARAM_STRING_BINARY, 0);
		g_pOnBroadcastVoice->PushCell(m_unWritten);
		g_pOnBroadcastVoice->Execute(&result);
	}

	DETOUR_STATIC_CALL(SV_BroadcastVoiceData)(client, nBytes, pVoiceData, unk4);
}

bool VoiceHook2::SDK_OnMetamodLoad(ISmmAPI *ismm, char *error, size_t maxlen, bool late)
{
	GET_V_IFACE_ANY(GetServerFactory, server, IServerGameDLL, INTERFACEVERSION_SERVERGAMEDLL);
	GET_V_IFACE_CURRENT(GetEngineFactory, icvar, ICvar, CVAR_INTERFACE_VERSION);

	g_pUseSteamVoice = icvar->FindVar("sv_use_steam_voice");

	return true;
}

bool VoiceHook2::SDK_OnLoad(char *error, size_t maxlength, bool late)
{
	char conf_error[255];
	if(!gameconfs->LoadGameConfigFile("voicehook2", &g_pGameConf, conf_error, sizeof(conf_error)))
	{
		error = conf_error;
		return false;
	}

	CDetourManager::Init(g_pSM->GetScriptingEngine(), g_pGameConf);
	g_pBroadcastVoiceData = DETOUR_CREATE_STATIC(SV_BroadcastVoiceData, "SV_BroadcastVoiceData");

	if (g_pBroadcastVoiceData == NULL)
	{
		return false;
	}

	g_pBroadcastVoiceData->EnableDetour();

	int tmp=6;
	state = speex_decoder_init(&speex_nb_mode);

	tmp=1;
	speex_decoder_ctl(state, SPEEX_SET_ENH, &tmp);

	tmp=16000;
	speex_decoder_ctl(state, SPEEX_SET_SAMPLING_RATE, &tmp);

	speex_bits_init(&bits);

	SH_ADD_HOOK_MEMFUNC(IServerGameDLL, GameServerSteamAPIActivated, server, this, &VoiceHook2::GameServerSteamAPIActivated, true);

	// Lets see if Steamworks is already active
	if(engine->GetGameServerSteamID()!=0)
#if SOURCE_ENGINE>=SE_CSGO
		GameServerSteamAPIActivated(true);
#else
		GameServerSteamAPIActivated();
#endif

	return true;
}

void VoiceHook2::SDK_OnUnload()
{
	if(g_pBroadcastVoiceData)
		g_pBroadcastVoiceData->Destroy();

	speex_decoder_destroy(state);
	speex_bits_destroy(&bits);

#ifdef _WIN32
	g_pClientEngine->ReleaseUser(g_hPipe, g_hUser);
	g_pClientEngine->BReleaseSteamPipe(g_hPipe);
#else
	g_pSteamClient->ReleaseUser(g_hPipe, g_hUser);
	g_pSteamClient->BReleaseSteamPipe(g_hPipe);
#endif

	SH_REMOVE_HOOK_MEMFUNC(IServerGameDLL, GameServerSteamAPIActivated, server, this, &VoiceHook2::GameServerSteamAPIActivated, true);
}

void VoiceHook2::SDK_OnAllLoaded()
{
	g_pOnBroadcastVoice = forwards->CreateForward("OnBroadcastVoice", ET_Event, 3, NULL, Param_Cell, Param_String, Param_Cell);
}

#if SOURCE_ENGINE >= SE_CSGO
void VoiceHook2::GameServerSteamAPIActivated(bool)
#else
void VoiceHook2::GameServerSteamAPIActivated()
#endif
{
	if(!g_pSteamUser && !g_pClientAudio)
	{
		char error[256];
		if(!GetClientAudio(error, sizeof(error)))
		{
			g_pSM->LogError(myself, "%s", error);
		}
	}
}

bool VoiceHook2::GetClientAudio(char *error, size_t maxlength)
{
	CLibrary m_hSteamClient("bin/steamclient");

	CreateInterfaceFn m_fnCreateInterface = (CreateInterfaceFn)m_hSteamClient.getAddress("CreateInterface");
	if(!m_fnCreateInterface)
	{
		snprintf(error, maxlength, "Failed to acquire CreateInterface pointer.");
		return false;
	}

	g_pClientEngine = (IClientEngine*)m_fnCreateInterface(CLIENTENGINE_INTERFACE_VERSION, NULL);
	if(!g_pClientEngine)
	{
		snprintf(error, maxlength, "Failed to acquire IClientEngine pointer.");
		return false;
	}

	g_pSteamClient = (ISteamClient012*)m_fnCreateInterface(STEAMCLIENT_INTERFACE_VERSION_012, NULL);
	if(!g_pSteamClient)
	{
		snprintf(error, maxlength, "Failed to acquire ISteamClient pointer.");
		return false;
	}

#ifdef _WIN32
	g_hUser = g_pClientEngine->CreateLocalUser(&g_hPipe, k_EAccountTypeIndividual);
#else
	g_hUser = g_pSteamClient->CreateLocalUser(&g_hPipe, k_EAccountTypeIndividual);
#endif

	g_pSteamUser = (ISteamUser017*)g_pSteamClient->GetISteamUser(g_hUser, g_hPipe, STEAMUSER_INTERFACE_VERSION_017);
	g_pClientAudio = (IClientAudio*)g_pClientEngine->GetIClientAudio(g_hUser, g_hPipe, CLIENTAUDIO_INTERFACE_VERSION);
	if(!g_pClientAudio && !g_pSteamUser)
	{
		snprintf(error, maxlength, "Failed to acquire IClientAudio pointer.");
		return false;
	}

	return true;
}