#ifndef _INCLUDE_SOURCEMOD_EXTENSION_PROPER_H_
#define _INCLUDE_SOURCEMOD_EXTENSION_PROPER_H_

#define STEAMWORKS_CLIENT_INTERFACES

#include <string>
#include "smsdk_ext.h"
#include "Steamworks.h"
#include "CLibrary.h"
#include "CDetour/detours.h"
#include "iclient.h"
#include "icvar.h"
#include "convar.h"

#include "speex/speex.h"

typedef void* (*CreateInterfaceFn)( const char *pName, int *pReturnCode );

class VoiceHook2 : public SDKExtension
{
public:
	virtual bool SDK_OnLoad(char *error, size_t maxlength, bool late);
	virtual void SDK_OnUnload();
	virtual void SDK_OnAllLoaded();
public:
	bool GetClientAudio(char *error, size_t maxlength);
#if SOURCE_ENGINE >= SE_CSGO
	void GameServerSteamAPIActivated(bool);
#else
	void GameServerSteamAPIActivated();
#endif
public:
#if defined SMEXT_CONF_METAMOD
	virtual bool SDK_OnMetamodLoad(ISmmAPI *ismm, char *error, size_t maxlength, bool late);
	//virtual bool SDK_OnMetamodUnload(char *error, size_t maxlength);
	//virtual bool SDK_OnMetamodPauseChange(bool paused, char *error, size_t maxlength);
#endif
};

#endif // _INCLUDE_SOURCEMOD_EXTENSION_PROPER_H_
